//----------------------------------------------------------------------------------
// tH[}bgϊpXbh
// Copyright (c) 2007  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <new>

#include "cnvthrd.h"
#include "convert.h"

// [J[Xbh
CConvThread::
CConvThread()
 : m_thread(0), m_reqEvt(0), m_finEvt(0), m_pParam(NULL), m_sse2(false)
{
	m_thNum = 1;
	m_thIdx = 0;
}

CConvThread::~CConvThread()
{
	Close();
}

bool CConvThread::Create(HANDLE reqEvt, HANDLE finEvt, CNV_PARAM *pp, bool sse2, int idx, int num)
{
	DWORD thid;

	//p[^̃Zbg
	m_reqEvt = reqEvt;
	m_finEvt = finEvt;
	m_pParam = pp;
	m_sse2 = sse2;
	m_thNum = (num < 1) ? 1 : num;
	m_thIdx = (idx < m_thNum && idx >=0) ? idx : 0;

	//p[^̃`FbN
	if(!m_reqEvt || !m_finEvt || !m_pParam){
		return false;
	}

	//łɃXbh
	if(m_thread){
		return true;
	}

	//Xbh̍쐬
	m_thread = CreateThread(NULL, 0, CConvThread::InitialThreadProc, this, 0, &thid);

	if(!m_thread){
		return false;
	}

	//vCIeB[callerƓɂ
	int pri = GetThreadPriority(GetCurrentThread());
	if(pri != THREAD_PRIORITY_ERROR_RETURN){
		SetThreadPriority(m_thread, pri);
	}

	return true;
}

bool CConvThread::Close(void)
{
	HANDLE thread = InterlockedExchangePointer(&m_thread, 0);
	if(thread){
		//Xbh̏I҂i炩ߒ~Kvj
		WaitForSingleObject(thread, INFINITE);
		CloseHandle(thread);
	}

	return true;
}


DWORD CConvThread::ThreadProc(void)
{
	bool loop = true;
	DWORD ret = 0;
	unsigned char *pIn,*pOut;
	unsigned int h,hh,w,is,os;

	while(loop){
		//v҂
		if(WAIT_OBJECT_0 != WaitForSingleObject(m_reqEvt, INFINITE)){
			ret = 1;
			loop = false;
			continue;
		}

		//vɂď
		pIn  = (unsigned char*)m_pParam->inPtr;
		pOut = (unsigned char*)m_pParam->outPtr;
		w = m_pParam->w;
		is = m_pParam->inStride;
		os = m_pParam->outStride;

		hh = h = m_pParam->h / m_thNum;
		if(m_thIdx == (m_thNum - 1)){
			//ŉ[
			h += m_pParam->h % m_thNum;
		}

		// ォ珇ɕ
		switch(m_pParam->type){
			case PYC_YUY2:
				pIn += sizeof(PIXEL_YC) * is * hh * m_thIdx;
				pOut += 2 * os * hh * m_thIdx;
				pyc_to_yuy2(pOut, (unsigned short*)pIn, h, w, is, os);
				break;
			case PYC_YUY2S:
				pIn += sizeof(PIXEL_YC) * is * hh * m_thIdx;
				pOut += 2 * os * hh * m_thIdx;
				pyc_to_yuy2s(pOut, (unsigned short*)pIn, h, w, is, os);
				break;
			case PYC_NV12:
				if(0 == m_thIdx){
					pyc_to_nv12(pOut, (unsigned short*)pIn, h, w, is, os);
				}
				break;
			case PYC_NV12S:
				if(0 == m_thIdx){
					pyc_to_nv12s(pOut, (unsigned short*)pIn, h, w, is, os);
				}
				break;
			case YUY2_PYC:
				pIn += 2 * is * hh * m_thIdx;
				pOut += sizeof(PIXEL_YC) * os * hh * m_thIdx;
				yuy2_to_pyc((unsigned short*)pOut, pIn, h, w, is, os);
				break;
			case YUY2S_PYC:
				pIn += 2 * is * hh * m_thIdx;
				pOut += sizeof(PIXEL_YC) * os * hh * m_thIdx;
				yuy2s_to_pyc((unsigned short*)pOut, pIn, h, w, is, os);
				break;
			case RGB32_PYC:
				pIn += 4 * is * hh * m_thIdx;
				pOut += sizeof(PIXEL_YC) * os * hh * m_thIdx;
				rgb32_to_pyc((unsigned short*)pOut, pIn, h, w, is, os);
				break;
			case RGB32S_PYC:
				pIn += 4 * is * hh * m_thIdx;
				pOut += sizeof(PIXEL_YC) * os * hh * m_thIdx;
				rgb32s_to_pyc((unsigned short*)pOut, pIn, h, w, is, os);
				break;
			case EXIT_CNV: //I
			default:
				loop = false;
		}

		//Iʒm
		SetEvent(m_finEvt);
	}

	return ret;
}

DWORD CConvThread::ThreadProcSSE2(void)
{
	bool loop = true;
	DWORD ret = 0;
	unsigned char *pIn,*pOut;
	unsigned int h,hh,w,is,os;

	while(loop){
		//v҂
		if(WAIT_OBJECT_0 != WaitForSingleObject(m_reqEvt, INFINITE)){
			ret = 1;
			loop = false;
			continue;
		}

		//vɂď
		pIn  = (unsigned char*)m_pParam->inPtr;
		pOut = (unsigned char*)m_pParam->outPtr;
		w = m_pParam->w;
		is = m_pParam->inStride;
		os = m_pParam->outStride;

		hh = h = m_pParam->h / m_thNum;
		if(m_thIdx == (m_thNum - 1)){
			//ŉ[
			h += m_pParam->h % m_thNum;
		}

		// ォ珇ɕ
		switch(m_pParam->type){
			case PYC_YUY2:
				pIn += sizeof(PIXEL_YC) * is * hh * m_thIdx;
				pOut += 2 * os * hh * m_thIdx;
				pyc_to_yuy2_SSE2(pOut, (unsigned short*)pIn, h, w, is, os);
				break;
			case PYC_YUY2S:
				pIn += sizeof(PIXEL_YC) * is * hh * m_thIdx;
				pOut += 2 * os * hh * m_thIdx;
				pyc_to_yuy2s_SSE2(pOut, (unsigned short*)pIn, h, w, is, os);
				break;
			case PYC_NV12:
				if(0 == m_thIdx){
					pyc_to_nv12(pOut, (unsigned short*)pIn, h, w, is, os);
				}
				break;
			case PYC_NV12S:
				if(0 == m_thIdx){
					pyc_to_nv12s(pOut, (unsigned short*)pIn, h, w, is, os);
				}
				break;
			case YUY2_PYC:
				pIn += 2 * is * hh * m_thIdx;
				pOut += sizeof(PIXEL_YC) * os * hh * m_thIdx;
				yuy2_to_pyc_SSE2((unsigned short*)pOut, pIn, h, w, is, os);
				break;
			case YUY2S_PYC:
				pIn += 2 * is * hh * m_thIdx;
				pOut += sizeof(PIXEL_YC) * os * hh * m_thIdx;
				yuy2s_to_pyc_SSE2((unsigned short*)pOut, pIn, h, w, is, os);
				break;
			case RGB32_PYC:
				pIn += 4 * is * hh * m_thIdx;
				pOut += sizeof(PIXEL_YC) * os * hh * m_thIdx;
				rgb32_to_pyc_SSE2((unsigned short*)pOut, pIn, h, w, is, os);
				break;
			case RGB32S_PYC:
				pIn += 4 * is * hh * m_thIdx;
				pOut += sizeof(PIXEL_YC) * os * hh * m_thIdx;
				rgb32s_to_pyc_SSE2((unsigned short*)pOut, pIn, h, w, is, os);
				break;
			case EXIT_CNV: //I
			default:
				loop = false;
		}

		//Iʒm
		SetEvent(m_finEvt);
	}

	return ret;
}

DWORD WINAPI CConvThread::InitialThreadProc(LPVOID p)
{
	CConvThread *pThread = (CConvThread *)p;

	if(pThread->m_sse2){
		return pThread->ThreadProcSSE2();
	}else{
		return pThread->ThreadProc();
	}
}

// tH[}bgϊ/XbhǗ
CConv::CConv()
: m_nWorkers(0), m_workers(NULL), m_pReqEvt(NULL), m_pFinEvt(NULL)
{
	ZeroMemory(&m_param, sizeof(m_param));
	m_sse2 = m_processing = false;
}

CConv::~CConv()
{
	Close();
}

bool CConv::Create(int nWorkers, bool sse2)
{
	if(nWorkers < 1 || nWorkers > 8){
		nWorkers = 1;
	}
	m_sse2 = sse2;

	if((m_nWorkers == nWorkers) && (m_workers != NULL)){
		//ύX̕KvȂ
		return true;
	}

	//܂\[XJ
	Close();

	//CxgIuWFNg̐
	m_nWorkers = nWorkers;
	m_pReqEvt = new(std::nothrow) HANDLE[m_nWorkers * 2];
	if(m_pReqEvt == NULL){
		return false;
	}
	m_pFinEvt = m_pReqEvt + m_nWorkers;
	ZeroMemory(m_pReqEvt, sizeof(HANDLE) * m_nWorkers * 2);

	for(int i=0; i<m_nWorkers * 2; i++){
		m_pReqEvt[i] = CreateEvent(NULL, FALSE, FALSE, NULL);
		if(m_pReqEvt[i] == NULL){
			//쐬s
			Close();
			return false;
		}
	}

	//[J[Xbh̐
	m_workers = new(std::nothrow) CConvThread[m_nWorkers];
	if(m_workers == NULL){
		Close();
		return false;
	}

	for(int i=0; i<m_nWorkers; i++){
		if(!m_workers[i].Create(m_pReqEvt[i], m_pFinEvt[i], &m_param, m_sse2, i, m_nWorkers)){
			//s
			Close();
			return false;
		}
	}

	return true;
}

bool CConv::Close(void)
{
	//[J[Xbh̍폜
	if(m_workers != NULL){
		m_param.type = EXIT_CNV;
		for(int i=0; i<m_nWorkers; i++){
			SetEvent(m_pReqEvt[i]);
			m_workers[i].Close();
		}
		delete[] m_workers;
		m_workers = NULL;
		m_param.type = PYC_YUY2;
	}

	//CxgIuWFNg̍폜
	if(m_pReqEvt != NULL){
		for(int i=0; i<m_nWorkers * 2; i++){
			if(m_pReqEvt[i] != NULL){
				CloseHandle(m_pReqEvt[i]);
			}
		}
		delete[] m_pReqEvt;
		m_pReqEvt = NULL;
	}
	m_pFinEvt = NULL;

	return true;
}

bool CConv::Request(const CNV_PARAM *pp)
{
	//Nς݂`FbN
	if(m_workers == NULL || pp == NULL){
		return false;
	}else if(m_processing){
		//v
		return false;
	}

	//p[^Rs[
	m_param = *pp;

	//̗vi񓯊j
	m_processing = true;
	for(int i=0; i<m_nWorkers; i++){
		SetEvent(m_pReqEvt[i]);
	}

	return true;
}

bool CConv::Wait()
{
	//Nς݂`FbN
	if(m_workers == NULL){
		return false;
	}else if(!m_processing){
		//vłȂ
		return false;
	}

	//I҂
	DWORD ret = WaitForMultipleObjects(m_nWorkers, m_pFinEvt, TRUE, INFINITE);
	m_processing = false;

	return (WAIT_OBJECT_0 <= ret) && (ret < WAIT_OBJECT_0 + m_nWorkers);
}
