/* convert.h
 * color converter header
 */
#ifndef _C_CONVERT_H_
#define _C_CONVERT_H_

#ifdef __cplusplus
extern "C"{
#endif

#ifndef PIXEL_YC
typedef	struct tag_PIXEL_YC {
    short y;
    short cb;
    short cr;
} PIXEL_YC;
#endif

int pyc_to_yuy2(unsigned char *dst, const unsigned short *src,
                unsigned int h, unsigned int w,
                unsigned int is, unsigned int os);

int pyc_to_yuy2_SSE2(unsigned char *dst, const unsigned short *src,
                     unsigned int h, unsigned int w,
                     unsigned int is, unsigned int os);

int yuy2_to_pyc(unsigned short *dst, const unsigned char *src,
                unsigned int h, unsigned int w,
                unsigned int is, unsigned int os);

int yuy2_to_pyc_SSE2(unsigned short *dst, const unsigned char *src,
                     unsigned int h, unsigned int w,
                     unsigned int is, unsigned int os);

int pyc_to_yuy2s(unsigned char *dst, const unsigned short *src,
                 unsigned int h, unsigned int w,
                 unsigned int is, unsigned int os);

int pyc_to_yuy2s_SSE2(unsigned char *dst, const unsigned short *src,
                      unsigned int h, unsigned int w,
                      unsigned int is, unsigned int os);

int yuy2s_to_pyc(unsigned short *dst, const unsigned char *src,
                 unsigned int h, unsigned int w,
                 unsigned int is, unsigned int os);

int yuy2s_to_pyc_SSE2(unsigned short *dst, const unsigned char *src,
                      unsigned int h, unsigned int w,
                      unsigned int is, unsigned int os);

int rgb32_to_pyc(unsigned short *dst, const unsigned char *src,
                 unsigned int h, unsigned int w,
                 unsigned int is, unsigned int os);

int rgb32_to_pyc_SSE2(unsigned short *dst, const unsigned char *src,
                      unsigned int h, unsigned int w,
                      unsigned int is, unsigned int os);

int rgb32s_to_pyc(unsigned short *dst, const unsigned char *src,
                  unsigned int h, unsigned int w,
                  unsigned int is, unsigned int os);

int rgb32s_to_pyc_SSE2(unsigned short *dst, const unsigned char *src,
                       unsigned int h, unsigned int w,
                       unsigned int is, unsigned int os);

int pyc_to_nv12(unsigned char *dst, const unsigned short *src,
                unsigned int h, unsigned int w,
                unsigned int is, unsigned int os);

int pyc_to_nv12s(unsigned char *dst, const unsigned short *src,
                 unsigned int h, unsigned int w,
                 unsigned int is, unsigned int os);

#ifdef __cplusplus
}
#endif

#endif /* _C_CONVERT_H_ */
