//----------------------------------------------------------------------------------
// aviutl  DXVA2 C^[[XۑTCYtB^
// Copyright (c) 2007  N099
//----------------------------------------------------------------------------------
#pragma once

#include "cnvthrd.h"

#ifndef D3DFMT_NV12
#define D3DFMT_NV12 (D3DFORMAT)(MAKEFOURCC('N', 'V', '1', '2'))
#endif

//p[^
struct DXVAFilterParam
{
	//vZbT[hCfbNX
	UINT mode;

	//o̓TCY
	UINT WidthIn;
	UINT HeightIn;
	UINT WidthOut;
	UINT HeightOut;
	UINT wMax;

	D3DFORMAT SrcFormat; //vZbT֓͂tH[}bg
	D3DFORMAT DstFormat; //vZbTo͂tH[}bg
	bool SrcFormatSub; //true:0-255, false:16-235
	bool DstFormatSub; //true:BT709, false:BT601 or 

	bool SrcAscend; //Tv̕я
};

//DXVA2 Video Processor tB^NX
class DXVAFilter
{
private:
	IDirect3D9 *m_pD3D; //IDirect3D9IuWFNg
	IDirect3DDevice9 *m_pd3dDevice; //D3DfoCX

	//DVXA2 Video Processor
	HMODULE m_hDXVA2DLL; //dxva2.dll
	IDirectXVideoProcessorService *m_pDXVAVProcService;
	IDirectXVideoProcessor *m_pDXVAVProcDevice;

	//^[QbgT[tFX
	static const size_t N_SAMP = 3;
	IDirect3DSurface9 *m_pSrfSrc[N_SAMP]; //cur,prev,...
	IDirect3DSurface9 *m_pSrfDst[2]; //1st,2nd
	IDirect3DSurface9 *m_pSrfDstTmp[2];

	DXVA2_VideoDesc m_VideoDesc; //̓rfI
	DXVA2_VideoProcessorCaps m_Caps; //processor caps

	//VideoProcessBltp[^
	DXVA2_VideoProcessBltParams m_BltParam;
	DXVA2_VideoSample m_BltSample[N_SAMP]; //cur,prev,...

	//vZbT[hCfbNX
	UINT m_mode;

	//o̓TCY
	UINT m_WidthIn;
	UINT m_HeightIn;
	UINT m_WidthOut;
	UINT m_HeightOut;
	UINT m_wMax;

	bool m_sse2;
	bool m_ascend;

	CNV_TYPE  m_SrcCnvType; //PYC->XXX̕ϊ^Cv
	CNV_TYPE  m_DstCnvType; //XXX->PYC̕ϊ^Cv
	D3DFORMAT m_SrcFormat; //̓T[tFX̃tH[}bg
	D3DFORMAT m_DstFormat; //o̓T[tFX̃tH[}bg

	//tB^p[^igpȂj
	DXVA2_ValueRange m_ProcAmpRanges[4];
	DXVA2_ValueRange m_NFilterRanges[6];
	DXVA2_ValueRange m_DFilterRanges[6];
	DXVA2_Fixed32 m_ProcAmpValues[4];
	DXVA2_Fixed32 m_NFilterValues[6];
	DXVA2_Fixed32 m_DFilterValues[6];

	//PIXEL_YCϊNX
	int m_ConvWorkers;
	CConv *m_pConv;

public:
	DXVAFilter(bool sse2 = true);
	~DXVAFilter();

	bool Init(const FILTER *fp);
	bool AllocResources(const DXVAFilterParam *para);
	bool ReleaseResources(void);
	bool ProcImage(PIXEL_YC *dst, const PIXEL_YC *src, int frame, bool tff, int out = 0);

	bool GetD3DInterface(IDirect3D9 **ppD3D, IDirect3DDevice9 **ppd3dDevice);

	int GetCurWidth(void) const { return m_WidthIn; }
	int GetCurHeight(void) const { return m_HeightIn; }
	int GetRefFrameNum(void) const { return N_SAMP; }

	void FlushCommand(void) { if(m_pd3dDevice){ DWORD p; m_pd3dDevice->ValidateDevice(&p); } }
	
private:
	HRESULT InitD3D(HWND hwnd);
	HRESULT InitDXVA2Service(void);
	HRESULT CreateDXVA2Processor(void);
	HRESULT CreateDXVA2Device(const GUID& guid);
	void DestroyDXVA2(void);
	HRESULT CreateSurface(void);
	void DestroySurface(void);

	HRESULT GetFilterRange(const GUID& guid);
	void InitProcParams(void);
	HRESULT PutPixelData(IDirect3DSurface9 *dst, const PIXEL_YC *src, CConv &cv);
	HRESULT GetPixelData(PIXEL_YC *dst, IDirect3DSurface9 *src, CConv &cv, bool top);
	HRESULT GetPixelData(PIXEL_YC *dst, IDirect3DSurface9 *src, CConv &cv);

	HRESULT AppendFrame(const PIXEL_YC *src, int frame, bool tff);

	HRESULT ProcBlt(PIXEL_YC *dst, DXVA2_VideoSample *vs, int n, int frame, bool tff);
	HRESULT ProcBlt0(DXVA2_VideoSample *vs, int n, int frame, bool tff);
	HRESULT ProcBlt1(PIXEL_YC *dst, DXVA2_VideoSample *vs, int n, int frame, bool tff);
	HRESULT ProcBlt2(PIXEL_YC *dst, DXVA2_VideoSample *vs, int n, int frame, bool tff);

	HRESULT ResetDevice(void);

	HRESULT ShowMessageBox(const char *file, DWORD line, HRESULT hr, const TCHAR *msg);
	bool isProcRGB(void) const { return m_DstFormat == D3DFMT_X8R8G8B8 || m_DstFormat == D3DFMT_A8R8G8B8; }
	LONGLONG toRefTime(int frame, int fps) { return (10000000LL * frame + fps/2)/fps; }

	void SwapSample(void);

	DXVA2_VideoSample *SampleToAppend(void) { return m_ascend ? m_BltSample : &m_BltSample[N_SAMP-1]; }
};

//---------------------------------------------------------------------
// macro
//---------------------------------------------------------------------
#ifndef SAFE_DELETE
#define SAFE_DELETE(p)       { if(p) { delete (p);     (p)=NULL; } }
#endif    
#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }
#endif    
#ifndef SAFE_RELEASE
#define SAFE_RELEASE(p)      { if(p) { (p)->Release(); (p)=NULL; } }
#endif
