//----------------------------------------------------------------------------------
// aviutl DXVA2 C^[[XۑTCYtB^
// Copyright (c) 2007  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <strsafe.h>
#include <new>

#include <d3d9.h>
#include <d3dx9.h>
#include <dxerr.h>
#include <dxva2api.h>

#include "filter.h"
#include "dxva2_proc.h"

//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
DXVAFilter *g_pDXVAFilter = NULL;
bool g_need_realloc = true;

//ptH[}Xp
#ifdef DBG_WINDOW
struct PCount { LARGE_INTEGER c; TCHAR s[16]; };
HWND g_debugWindow = 0;
DWORD g_cpuFreq = 0;
double g_ticCoeff = 1.0;
double g_timCoeff = 1.0;
PCount g_count[6];
void getCount(int i, const TCHAR *tag);
void printCount(int n);
#else
#define getCount(i, t)
#define printCount(n)
#endif

static inline bool isTFF(const FILTER_PROC_INFO *fpip)
{
	return (fpip->flag & FILTER_PROC_INFO_FLAG_INVERT_FIELD_ORDER) ? true : false;
}

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
// UNICODErh邽ߏςɂȂĂ܂iDXTrace()Ȃ߁j
#define TRACK_N 4
enum { T_X, T_Y, T_PMODE, T_PFMT };

#define CHECK_N 1
enum { C_DEINT };

LPSTR track_name[] =
{ "X/2", "Y/2", "Mode", "Format" };
int track_default[] = { 320, 240, 0, 0 };
int track_s[] = { 16, 16, 0, 0 };
int track_e[] = { 2048, 2048, 7, 5 };

LPSTR check_name[] = { "fC^[Xʕ\(Debug)" };
int check_default[] = { 0 };

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION, 0, 0,
	(TCHAR*)"C^ۑ gk 2",
	TRACK_N, (TCHAR**)track_name, track_default, track_s, track_e,
	CHECK_N, (TCHAR**)check_name, check_default,
	func_proc,
	func_init,
	func_exit,
	func_update,
	func_WndProc,
	NULL, NULL, NULL, 0,
	(TCHAR*)"dxva_ires for vista by N099, ver0.2",
	NULL,  NULL,
};

//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}

//---------------------------------------------------------------------
// ɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
	//vistaȍ~̂ݑΉ
	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osvi);

	if(osvi.dwMajorVersion < 6){
		MessageBoxA(NULL, "Windows Vista ȍ~ł̂ݓ삵܂",
			(CHAR*)filter.name, MB_ICONERROR|MB_SYSTEMMODAL);
		return FALSE;
	}

	//DXVAFilter
	g_pDXVAFilter = new(std::nothrow) DXVAFilter;
	if(NULL == g_pDXVAFilter){
		return FALSE;
	}

	//
	if(!g_pDXVAFilter->Init(fp)){
		SAFE_DELETE(g_pDXVAFilter);
		return FALSE;
	}

	//őTCY擾
	SYS_INFO si = {0};
	if(!fp->exfunc->get_sys_info(NULL, &si)){
		SAFE_DELETE(g_pDXVAFilter);
		return FALSE;
	}else{
		track_s[0] = (si.min_w + 1)/2;
		track_s[1] = (si.min_h + 1)/2;
		track_e[0] = (si.max_w + 1)/2;
		track_e[1] = (si.max_h + 1)/2;
		fp->exfunc->filter_window_update(fp);
	}

#ifdef DBG_WINDOW
	//get CPU freq from registryi܂萳mł͂Ȃj
	HKEY hKey;
	DWORD size = sizeof(DWORD);
	if(ERROR_SUCCESS == RegOpenKeyEx(HKEY_LOCAL_MACHINE, 
		TEXT("HARDWARE\\DESCRIPTION\\System\\CentralProcessor\\0"),
		0, KEY_READ, &hKey))
	{
		g_cpuFreq = 0;
		RegQueryValueEx(hKey, TEXT("~MHz"), NULL, NULL, (LPBYTE)&g_cpuFreq, &size);
		RegCloseKey(hKey);
	}

	//coeff PerformanceCounter ticks to CPU cycles
	LARGE_INTEGER ticFreq = {0,0};
	QueryPerformanceFrequency(&ticFreq);
	if(g_cpuFreq>0 && ticFreq.QuadPart>0){
		g_ticCoeff = g_cpuFreq * 1000.0 * 1000.0 / (double)ticFreq.QuadPart;
		g_timCoeff = 1.0 / (double)ticFreq.QuadPart;
	}else{
		g_ticCoeff = g_timCoeff = 1.0;
	}

	//create debug window
	g_debugWindow = CreateWindow(TEXT("EDIT"), TEXT("Debug DXVA_IRES"),
		WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION | ES_MULTILINE | ES_READONLY,
		CW_USEDEFAULT, 0,
		180, 160,
		fp->hwnd, NULL, fp->dll_hinst, NULL);
	if(g_debugWindow){
		SendMessage(g_debugWindow, WM_SETFONT, 
			(WPARAM)GetStockObject(OEM_FIXED_FONT), (LPARAM)TRUE);
	}
#endif

	return TRUE;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit(FILTER *fp)
{
#ifdef DBG_WINDOW
	if(g_debugWindow) DestroyWindow(g_debugWindow);
#endif

	SAFE_DELETE(g_pDXVAFilter);

	return TRUE;
}


//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
	int i = 0;
	static int frame = -2; //O񏈗t[ԍ
	static DXVAFilterParam param;
	static int pre_frames = 1;

	if(!g_pDXVAFilter) return FALSE;

	getCount(i++, TEXT("Init"));

	//TCYύX̃`FbN
	if(fpip->w != g_pDXVAFilter->GetCurWidth() || fpip->h != g_pDXVAFilter->GetCurHeight()){
		g_need_realloc = true;
	}

	//p[^ύXꂽꍇ
	if(g_need_realloc){
		//\[X̊J
		g_pDXVAFilter->ReleaseResources();

		//[h
		param.mode = fp->track[T_PMODE];

		//TCY
		param.WidthIn   = fpip->w/2;
		param.WidthIn  *= 2;
		param.HeightIn  = fpip->h/2;
		param.HeightIn *= 2;
		param.WidthOut  = fp->track[T_X] * 2;
		param.HeightOut = fp->track[T_Y] * 2;
		param.wMax      = fpip->max_w;

		if((int)param.WidthOut > param.wMax || (int)param.HeightOut > fpip->max_h){
			//g̃TCY傫
			return FALSE;
		}

		//tH[}bg
		param.SrcFormat    = (fp->track[T_PFMT] & 0x1) ? D3DFMT_NV12 : D3DFMT_YUY2;
		param.SrcFormatSub = false;
		param.DstFormat    = (fp->track[T_PFMT] & 0x4) ? D3DFMT_YUY2 : D3DFMT_X8R8G8B8;
		param.DstFormatSub = (fp->track[T_PFMT] & 0x2) ? true : false;
		param.SrcAscend    = false;

		//\[X̊l
		if(!g_pDXVAFilter->AllocResources(&param)){
			return FALSE;
		}
		getCount(i++, TEXT("Alloc"));

		g_need_realloc = false;
		frame = -2;
		pre_frames = g_pDXVAFilter->GetRefFrameNum();
	}

	//Qƃt[ĂȂꍇ͂̕𑗂
	if((fpip->frame < frame) || (abs(frame - fpip->frame) > 1)){
		for(int j = 0; j<pre_frames; ++j){
			//݂̂lĂ
			if(!g_pDXVAFilter->ProcImage(NULL, fpip->ycp_edit, fpip->frame + j, isTFF(fpip))){
				return FALSE;
			}
		}
	}

	//̖{
	if(!g_pDXVAFilter->ProcImage(fpip->ycp_temp, 
		(frame == fpip->frame) ? NULL : fpip->ycp_edit,
		fpip->frame + pre_frames, isTFF(fpip), fp->check[C_DEINT]))
	{
		return FALSE;
	}

	//|C^̓ւ
	PIXEL_YC *tmp  = fpip->ycp_edit;
	fpip->ycp_edit = fpip->ycp_temp;
	fpip->ycp_temp = tmp;

	frame = fpip->frame;
	fpip->h = param.HeightOut;
	fpip->w = param.WidthOut;

	getCount(i++, TEXT("Proc "));

	printCount(i);

	return TRUE;
}

//---------------------------------------------------------------------
// ݒύXɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_update(FILTER *fp, int status)
{
	if(status != (FILTER_UPDATE_STATUS_CHECK + C_DEINT)){
		g_need_realloc = true;
	}

	return TRUE;
}

//---------------------------------------------------------------------
// ݒEBhEɃEBhEbZ[WɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_WndProc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam,void *editp,FILTER *fp)
{
	HWND h = NULL;

	switch(message){
	case WM_FILTER_INIT:
		//`FbN{bNX3stateɂ
		h = FindWindowExA(hwnd, NULL, "BUTTON", check_name[C_DEINT]);
		if(h != NULL){
			SetWindowLongPtr(h, GWL_STYLE, WS_CHILDWINDOW|WS_VISIBLE|BS_AUTO3STATE);
		}
		return TRUE;
	case WM_FILTER_CHANGE_ACTIVE: //tB^̗L/ύXꂽɑ܂
		if(g_pDXVAFilter && !fp->exfunc->is_filter_active(fp)){
			g_pDXVAFilter->ReleaseResources();
			g_need_realloc = true;
		}
		break;
	default:
		break;
	}

	return FALSE;
}

//ptH[}Xp
#ifdef DBG_WINDOW
void getCount(int i, const TCHAR *tag)
{
	QueryPerformanceCounter(&g_count[i].c);
	lstrcpy(g_count[i].s, tag);
}

void printCount(int n)
{
	TCHAR buf[512];
	TCHAR buf0[64];
	double clk;
	int h,w;

	if(NULL == g_debugWindow) return;
	if(g_pDXVAFilter){
		h = g_pDXVAFilter->GetCurHeight();
		w = g_pDXVAFilter->GetCurWidth();
	}else{
		h = w = 0;
	}

	wsprintf(buf, TEXT("size:%dx%d\r\ncycles(CPU:%dMHz)\r\n"), 
		w,h, g_cpuFreq);
	for(int i=1; i<n; ++i){
		clk = (double)(g_count[i].c.QuadPart - g_count[i-1].c.QuadPart)*g_ticCoeff;
		StringCchPrintf(buf0, 64, TEXT("%s:%5e\r\n"), g_count[i].s, clk);
		lstrcat(buf, buf0);
	}
	SendMessage(g_debugWindow, WM_SETTEXT, 0, (LPARAM)buf);  
}
#endif